/* Linux _CNg DACS-1500/2500 ʐMTvvO
   LD15DIDR.c    2016/12/5    _bNXZ */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include<time.h>
#include "ftd2xx.h"

int main()
{
    FT_STATUS   ftStatus;
    FT_HANDLE   ftHandle[16];
    int iport;
    int r; 
    DWORD       numDevs;
    DWORD       WriteNum, TransNum;
    DWORD       ReadNum, RecNum, EventDword;
    char        kinbuf[256];
    char        buf[1024];
    static      FT_PROGRAM_DATA Data;
    int swID;
    int swIDtable[16] = {99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99};
                                     /* {[hXCb`ݒIDԍe[u
                                        IDԍ(0`15)Ƀ|[gԍZbg */
    int DevEnable = 0;               /* DACSfoCX̐ڑȂƂ1ȏ゠ */

    /* foCX̊mF */

    ftStatus = FT_ListDevices(&numDevs,NULL,FT_LIST_NUMBER_ONLY);  /* ڑfoCX擾 */

    printf("FT device numbers = %d\n\n", numDevs);
    if(numDevs == 0) return(0);      /* foCXȂƂ͏I */

    system("modprobe -r ftdi_sio");  /* zCOMhCoo^͂
                                        _CNgł𓮍\Ƃ邽 */
    /* DACSfoCX̊mF */

    for(iport = 0; iport != (int)numDevs; iport++){  /* foCX̂Ԃ */
        r = 0;
        do{                          /* foCXOPEN */
            ftStatus = FT_Open(iport, &ftHandle[iport]);
            usleep(100);
            r++;
            if(r > 100) break;
        }while(ftStatus != FT_OK);

        if(ftStatus != FT_OK){       /* OPEN łȂƂ͎̃|[g */
            printf("Port %d Open NG\n", iport);
            continue;
        }

        /* OPEN łƂ */

        printf("Port %d Open OK\n", iport);

        /* EEPROM̓eǎ
           ̃vOł͓ǎ݂̂ƂĂ邪
           DACSiȊOFTDIfoCXgpĂƂ
           Manufacturer Ȃǂ环ʂ邱Ƃł */

        Data.Signature1 = 0x00000000;
        Data.Signature2 = 0xffffffff;
        Data.Manufacturer = (char *)malloc(256);
        Data.ManufacturerId = (char *)malloc(256);
        Data.Description = (char *)malloc(256);
        Data.SerialNumber = (char *)malloc(256);
        
        ftStatus = FT_EE_Read(ftHandle[iport], &Data);
        if(ftStatus == FT_OK){
            printf("VendorId = 0x%04X\n", Data.VendorId);
            printf("ProductId = 0x%04X\n", Data.ProductId);
            printf("Manufacturer = %s\n", Data.Manufacturer);
            printf("ManufacturerId = %s\n", Data.ManufacturerId);
            printf("Description = %s\n", Data.Description);
            printf("SerialNumber = %s\n", Data.SerialNumber);
        }
        
        free(Data.Manufacturer);
        free(Data.ManufacturerId);
        free(Data.Description);
        free(Data.SerialNumber);

        ftStatus = FT_SetChars(ftHandle[iport],0x0d,1,0x0,0);  /* ؂蕶ݒ */
        ftStatus = FT_SetTimeouts(ftHandle[iport],100,100);    /* ^CAEgԂݒ */

        /* IDԍ
           16IDԍWR}h𑗐MmF */

        WriteNum = 9;
        sprintf(kinbuf,"W0000000 ");
        kinbuf[8] = 0xd;
        for(swID = 0; swID != 16; swID++){
            kinbuf[1] = (char)(0x30 + swID);
            if(kinbuf[1] > 0x39) kinbuf[1] = kinbuf[1] + 7;
            TransNum = 0;
            ftStatus = FT_Write(ftHandle[iport],kinbuf,WriteNum,&TransNum); /* f[^M */
            r = 0;
            do{
                ReadNum = 0;
                FT_GetStatus(ftHandle[iport],&ReadNum,&TransNum,&EventDword); /* Mf[^擾 */
                usleep(100);
                r++;
                if(r > 100) break; 
            }while(ReadNum == 0);
            if(ReadNum > 0){
                ftStatus = FT_Read(ftHandle[iport],buf,ReadNum,&RecNum); /* f[^M */
                break;           /* ΌI */
            }
        }
        if(swID < 16){           /* IDԍIƂ */
            printf("DIP-SW ID = %d\n\n", swID);
            swIDtable[swID] = iport;   /* IDԍe[uɃ|[gԍo^ */
            DevEnable = 1;             /* ȂƂ1DACSfoCXƂ */
        }
        else{                    /* vIDԍȂƂ */
            printf("NO DACS Device\n\n");
            ftStatus = FT_Close(ftHandle[iport]); /* foCXclose */
        }
    }

    /* f[^M */

    if(DevEnable){                   /* ȂƂ1DACSfoCXꍇ̂ݑMs */
        do{
            printf("keyin > ");
            fgets(kinbuf, 256, stdin);            /* R}hL[ */
            if(kinbuf[0] == '-') break;

            swID = kinbuf[1] - 0x30;              /* L[͂IDԍmF */
            if(swID > 9) swID = swID -7;
            if((swID < 0) || (swID > 15)){
                printf("     check ID code\n");
                continue;
            }
            iport = swIDtable[swID];
            if(iport == 99){                      /* YIDԍ̃foCXȂꍇ */
                printf("     check ID number\n");
                continue;
            } 

            printf("     Tx data = %s", kinbuf);
            r = strlen(kinbuf);
            kinbuf[r-1] = 0xd;
            WriteNum = r;
            TransNum = 0;
            ftStatus = FT_Write(ftHandle[iport],kinbuf,WriteNum,&TransNum);  /* f[^M */

            r = 0;
            do{
                ReadNum = 0;
                FT_GetStatus(ftHandle[iport],&ReadNum,&TransNum,&EventDword); /* Mf[^擾 */
                usleep(100);
                r++;
                if(r > 100) break; 
            }while(ReadNum == 0);

            if(ReadNum > 0){
                ftStatus = FT_Read(ftHandle[iport],buf,ReadNum,&RecNum); /* f[^M */
                r = RecNum;
                buf[r] = 0;
                printf("     Rx data = %s\n", buf);
            }
            else printf("Timeout error\n");

        }while(1);
    }

    /* I */

    for(swID = 0; swID != 16; swID++){            /* foCXclose */
        iport = swIDtable[swID];
        if(iport != 99) ftStatus = FT_Close(ftHandle[iport]);
    }
    system("modprobe ftdi_sio");     /* zCOMhCoo^
                                        ftHgɂǂ */

    return(0);
}
